#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MIN -1024
#define MAX 1024

// Compare for qsort
int compare (const void* a, const void* b) {
    if (*(int*)a==*(int*)b)
    return 0;
    else
    if (*(int*)a < *(int*)b)
        return -1;
     else
      return 1;        
}

void fillRand(int *arr, int n) {
   long i;

   for(i = 0; i < n; i ++)
         arr[i] = (rand() / (double) RAND_MAX)*(MAX - MIN) + MIN;
}

/* end is the last index + 1 */
void csort(int array[], const int end, const int max, const int min)
{
  int i;
  const int range = max-min+1;
  int *count, *scratch;
  
  count = (int*) malloc ((range+1)*sizeof(int));
  scratch = (int*) malloc (end*sizeof(int));

  for(i=0; i<range+1; i++)
    count[i] = 0;
 
  /* Set the value of count[i] to the number of
   * elements in array with value i+min-1. */
  for(i=0; i<end; i++) {
    int c = array[i]+1-min;
    count[c]++;
  }
 
  /* Update count[i] to be the number of
   * elements with value less than i+min. */
  for(i=1; i<range; i++)
    count[i] += count[i-1];
 
  /* Copy the elements of array into scratch in
   * stable sorted order. */
  for(i=(end-1); i>=0; i--) {
    int c = array[i]-min;
    int s = count[c];
    scratch[s] = array[i];
    /* Increment count so that the next element
     * with the same value as the current element
     * is placed into its own position in scratch. */
    count[c]++;
  }
 
  for(i=0; i<end; i++)
    array[i] = scratch[i];

  free(count);
  free(scratch);
}


int main (int argc, char* argv[]) {
  
  int *A, *B, n, i, ok;

  srand(time(NULL));

  n = atoi(argv[1]);
  A = (int *) malloc(n * sizeof(int));
  B = (int *) malloc(n * sizeof(int));
  
  fillRand(A, n);
  memcpy(B, A, n * sizeof(int)); 
  
  csort(A, n, MAX, MIN);
  qsort(B, n, sizeof(int), compare);

  ok = 1;
  for (i = 0; i < n; i++) {
        if (A[i] != B[i]) {
          ok = 0;  
          break;            
        }
  }

  if (ok) {
    printf("Test PASSED\n");
  } else {
    printf("Test FAILED\n");
  }

  free(A);
  free(B);
  return 0;
}
